------------------
--Config default settings
local defaults = {
	["t"] = .5,
	["idletimer"] = 15,
	["inraid"] = false,
	["incombat"] = false,
	["suppress"] = false,
	["aftercombat"] = false,
	["chat"] = true,
	["whisper"] = true,
	["say"] = true,
	["raid"] = true,
	["party"] = true,
	["guild"] = true,
	["instance"] = true,
	["avm"] = true,
	["comm"] = true,
	["emote"] = true,
	["monster"] = true,
	["yell"] = true,
	["system"] = true,
	["chmsg"] = false,
	["fadealpha"] = 0,
	--["hideminimap"] = false,
}
local isIdle = false
local defaultChannels = {}
local activeChannels = { GetChatWindowMessages(SELECTED_CHAT_FRAME:GetID()) }
local activeChannellist = { GetChannelList() }
local chatCVar = ""
------------------

scfOptions = {}
scfChannels = {}
local scf = CreateFrame("Frame")
local frames = {_}--, GeneralDockManager, ChatFrameMenuButton}
local chatFrames = {}
local MouseoverFrames = {}
local idle = CreateFrame("Frame");
--Events
local event = CreateFrame("Frame")
event:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)

--TODO settings loading/saving, this has become a mess
--event:RegisterEvent("ADDON_LOADED") alt?
--event:RegisterEvent("PLAYER_REGEN_ENABLED")
--event:RegisterEvent("PLAYER_REGEN_DISABLED")
event:RegisterEvent("PLAYER_LOGIN")
if WOW_PROJECT_ID == WOW_PROJECT_MAINLINE then
	event:RegisterEvent("PET_BATTLE_CLOSE")
	event:RegisterEvent("PET_BATTLE_OPENING_START")
end
--event:RegisterEvent("CHAT_MSG_CHANNEL")
--event:RegisterEvent("CHAT_MSG_SAY")
--event:RegisterEvent("CHAT_MSG_MONSTER_SAY")
--event:RegisterEvent("CHAT_MSG_WHISPER")
--event:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
--event:RegisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
--event:RegisterEvent("CHAT_MSG_BN_WHISPER")
--event:RegisterEvent("CHAT_MSG_RAID_LEADER")
--event:RegisterEvent("CHAT_MSG_RAID")
--event:RegisterEvent("CHAT_MSG_PARTY_LEADER")
--event:RegisterEvent("CHAT_MSG_PARTY")
--event:RegisterEvent("CHAT_MSG_GUILD")
--event:RegisterEvent("CHAT_MSG_OFFICER")
--event:RegisterEvent("CHAT_MSG_INSTANCE_CHAT")
--event:RegisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
--event:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
--event:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
--event:RegisterEvent("CHAT_MSG_COMMUNITIES_CHANNEL")
--event:RegisterEvent("CHAT_MSG_EMOTE")
--event:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
--event:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
--event:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
--event:RegisterEvent("CHAT_MSG_MONSTER_WHISPER")
--event:RegisterEvent("CHAT_MSG_MONSTER_YELL")
--event:RegisterEvent("CHAT_MSG_YELL")
--event:RegisterEvent("CHAT_MSG_SYSTEM")
--event:RegisterEvent("TIME_PLAYED_MSG")
--event:RegisterEvent("WHO_LIST_UPDATE")

function event:CHAT_MSG_GUILD_ACHIEVEMENT()
	if scf:IsInArray(activeChannels, "GUILD_ACHIEVEMENT") then
		scf:showChat()
	end
end

function event:CHAT_MSG_ACHIEVEMENT()
	if scf:IsInArray(activeChannels, "ACHIEVEMENT") then
		scf:showChat()
	end
end

function event:CHAT_MSG_COMMUNITIES_CHANNEL()
	--if scf:IsInArray(activeChannels, "COMMUNITIES_CHANNEL") then --todo lookup
		scf:showChat()
	--end
end

function event:CHAT_MSG_EMOTE()
	if scf:IsInArray(activeChannels, "EMOTE") then
		scf:showChat()
	end
end

function event:CHAT_MSG_TEXT_EMOTE()
	if scf:IsInArray(activeChannels, "EMOTE") then
		scf:showChat()
	end
end

function event:CHAT_MSG_RAID_BOSS_EMOTE()
	if scf:IsInArray(activeChannels, "MONSTER_BOSS_EMOTE") then
		scf:showChat()
	end
end

function event:CHAT_MSG_MONSTER_EMOTE()
	if scf:IsInArray(activeChannels, "MONSTER_EMOTE") then
		scf:showChat()
	end
end

function event:CHAT_MSG_MONSTER_WHISPER()
	if scf:IsInArray(activeChannels, "MONSTER_WHISPER") then
		scf:showChat()
	end
end

function event:CHAT_MSG_MONSTER_YELL()
	if scf:IsInArray(activeChannels, "MONSTER_YELL") then
		scf:showChat()
	end
end

function event:CHAT_MSG_YELL()
	if scf:IsInArray(activeChannels, "YELL") then
		scf:showChat()
	end
end

function event:CHAT_MSG_SYSTEM()
	if scf:IsInArray(activeChannels, "SYSTEM") then
		scf:showChat()
	end
end

function event:TIME_PLAYED_MSG()
	if scf:IsInArray(activeChannels, "SYSTEM") then
		scf:showChat()
	end
end

function event:WHO_LIST_UPDATE()
	if scf:IsInArray(activeChannels, "SYSTEM") then
		scf:showChat()
	end
end

function event:CHAT_MSG_INSTANCE_CHAT()
	if scf:IsInArray(activeChannels, "INSTANCE_CHAT") then
		scf:showChat()
	end
end

function event:CHAT_MSG_INSTANCE_CHAT_LEADER()
	if scf:IsInArray(activeChannels, "INSTANCE_CHAT_LEADER") then
		scf:showChat()
	end
end

function event:CHAT_MSG_CHANNEL(message, author, lang, _, _, flag, zoneid, channelnumber, channelname, senderuid)
	if scfOptions.chmsg then
		if ((scfChannels[channelnumber]) or (scfChannels[channelname])) then
			if scf:IsInArray(activeChannellist, channelnumber) then
				scf:showChat()
			end			
		end
		--if ((scfChannels == nil) or (not next(scfChannels))) then
		if (((scfChannels == nil) or (not next(scfChannels))) and channelname ~= "LookingForGroup" ) then
			if scf:IsInArray(activeChannellist, channelnumber) then
				scf:showChat()
			end		
		end
	end
end

function event:PLAYER_REGEN_ENABLED()
	if ((scfOptions.inraid and IsInRaid()) or not(scfOptions.inraid)) then
		if scfOptions.aftercombat then
			scf:showChat()
		end
	end
end

function event:PLAYER_REGEN_DISABLED()
	if ((scfOptions.inraid and IsInRaid()) or not(scfOptions.inraid)) then
		scf:hideChat()
	end
end

function event:PLAYER_LOGIN()
	scf:Init()
end

function event:PET_BATTLE_CLOSE()
	scf:showChat()
end

function event:PET_BATTLE_OPENING_START()
	scf:hideChat()
end

function event:CHAT_MSG_SAY()
	if scf:IsInArray(activeChannels, "SAY") then
		scf:showChat()
	end
end

function event:CHAT_MSG_MONSTER_SAY()
	if scf:IsInArray(activeChannels, "MONSTER_SAY") then
		scf:showChat()
	end
end


function event:CHAT_MSG_WHISPER()
	if scf:IsInArray(activeChannels, "WHISPER") then
		scf:showChat()
	end
end

function event:CHAT_MSG_WHISPER_INFORM()
	if scf:IsInArray(activeChannels, "WHISPER") then
		scf:showChat()
	end
end

function event:CHAT_MSG_BN_WHISPER_INFORM()
	if scf:IsInArray(activeChannels, "BN_WHISPER_INFORM") then
		scf:showChat()
	end
end

function event:CHAT_MSG_BN_WHISPER()
	if scf:IsInArray(activeChannels, "BN_WHISPER") then
		scf:showChat()
	end
end

function event:CHAT_MSG_RAID_LEADER()
	if scf:IsInArray(activeChannels, "RAID_LEADER") then
		scf:showChat()
	end
end

function event:CHAT_MSG_RAID()
	if scf:IsInArray(activeChannels, "RAID") then
		scf:showChat()
	end
end

function event:CHAT_MSG_PARTY_LEADER()
	if scf:IsInArray(activeChannels, "PARTY_LEADER") then
		scf:showChat()
	end
end

function event:CHAT_MSG_PARTY()
	if scf:IsInArray(activeChannels, "PARTY") then
		scf:showChat()
	end
end

function event:CHAT_MSG_GUILD()
	if scf:IsInArray(activeChannels, "GUILD") then
		scf:showChat()
	end
end

function event:CHAT_MSG_OFFICER()
	if scf:IsInArray(activeChannels, "OFFICER") then
		scf:showChat()
	end
end



--Config load user settings
function scf:getOptions()

	if scfOptions.t ~= nil then
		scf:sett(scfOptions.t)
	else
		scf:sett(defaults.t)
	end
	
	if scfOptions.idletimer ~= nil then
		scfOptions.idletimer = scf:Round(scfOptions.idletimer, 0)		
		scf:setidletimer(scfOptions.idletimer)
	else
		scf:setidletimer(defaults.idletimer)
	end

	if scfOptions.inraid ~= nil then
		scf:setinraid(scfOptions.inraid)
	else
		scf:setinraid(defaults.inraid)
	end
	
	if scfOptions.incombat ~= nil then
		scf:setincombat(scfOptions.incombat)
	else
		scf:setincombat(defaults.incombat)
	end
	
	if scfOptions.suppress ~= nil then
		scf:setsuppress(scfOptions.suppress)
	else
		scf:setsuppress(defaults.suppress)
	end
	
	if scfOptions.aftercombat ~= nil then
		scf:setaftercombat(scfOptions.aftercombat)
	else
		scf:setaftercombat(defaults.aftercombat)
	end
	
	if scfOptions.chat ~= nil then
		scf:setchat(scfOptions.chat)
	else
		scf:setchat(defaults.chat)
	end
	
	if scfOptions.whisper ~= nil then
		scf:setwhisper(scfOptions.whisper)
	else
		scf:setwhisper(defaults.whisper)
	end
	
	if scfOptions.say ~= nil then
		scf:setsay(scfOptions.say)
	else
		scf:setsay(defaults.say)
	end
	
	if scfOptions.guild ~= nil then
		scf:setguild(scfOptions.guild)
	else
		scf:setguild(defaults.guild)
	end
	
	if scfOptions.party ~= nil then
		scf:setparty(scfOptions.party)
	else
		scf:setparty(defaults.party)
	end
	
	if scfOptions.raid ~= nil then
		scf:setraid(scfOptions.raid)
	else
		scf:setraid(defaults.raid)
	end
	
	if scfOptions.instance ~= nil then
		scf:setinstance(scfOptions.instance)
	else
		scf:setinstance(defaults.instance)
	end 
	
	if scfOptions.avm ~= nil then
		scf:setavm(scfOptions.avm)
	else
		scf:setavm(defaults.avm)
	end
	
	if scfOptions.comm ~= nil then
		scf:setcomm(scfOptions.comm)
	else
		scf:setcomm(defaults.comm)
	end
	
	if scfOptions.emote ~= nil then
		scf:setemote(scfOptions.emote)
	else
		scf:setemote(defaults.emote)
	end
	
	if scfOptions.monster ~= nil then
		scf:setmonster(scfOptions.monster)
	else
		scf:setmonster(defaults.monster)
	end
	
	if scfOptions.yell ~= nil then
		scf:setyell(scfOptions.yell)
	else
		scf:setyell(defaults.yell)
	end
	
	if scfOptions.fadealpha ~= nil then
		scf:setfadealpha(scfOptions.fadealpha)
	else
		scf:setfadealpha(defaults.fadealpha)
	end
	
	if scfOptions.system ~= nil then
		scf:setsystem(scfOptions.system)
	else
		scf:setsystem(defaults.system)
	end
	
	if scfOptions.chmsg ~= nil then
		scf:setchmsg(scfOptions.chmsg)
	else
		scf:setchmsg(defaults.chmsg)
	end
	
	if scfChannels ~= nil then
		defaultChannels = scfChannels
	
	end
	
	--[[
	if scfOptions.hideminimap ~= nil then
		scf:sethideminimap(scfOptions.hideminimap)
	else
		scf:sethideminimap(defaults.hideminimap)
	end
	]]--
end


--options panel
local panel = CreateFrame("FRAME")
local inraidcheck
local incombatcheck
local suppresscheck
local aftercombatcheck
local chatcheck
local whispercheck
local saycheck
local yellcheck
local guildcheck
local partycheck
local raidcheck
local instancecheck
local commcheck
local avmcheck
local emotecheck
local monstercheck
local systemcheck
local chmsgcheck
local channeltext
local chnumbox
local idletimerslider
local idletimertext
local fadealphaslider
local fadealphatext
--local hideminimapcheck

--local tempsettings = {}
--local preSettings = {}
--local preChannels = {}



function scf:createPanel()
	panel.name = "Smart Chat Fade"
	InterfaceOptions_AddCategory(panel)

	--panel.okay = function (self) scf:okay(); end;
	--panel.cancel = function (self) scf:cancel(); end;
	panel.default = function (self) scf:default(); end;
	
	--preSettings = table.copy(scfOptions)
	--preChannels = scfChannels

	local templatecheck = "ChatConfigCheckButtonTemplate"
	local ypos = -10
	local xpos = 25
	local ydis = -20

	inraidcheck = CreateFrame("CheckButton", "inraid", panel, templatecheck)
	inraidcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(inraidcheck:GetName() .. 'Text'):SetText(" in raid only")
	inraidcheck.tooltip = "only applies your settings if you are in a raidgroup"
	if scfOptions.inraid ~= nil then
		inraidcheck:SetChecked(scfOptions.inraid)
	else
		inraidcheck:SetChecked(defaults.inraid)
	end
	inraidcheck:SetScript("OnClick", 
	function()
		scf:setinraid(inraidcheck:GetChecked())
	end
	);
	
	incombatcheck = CreateFrame("CheckButton", "incombat", panel, templatecheck)
	ypos = ypos + ydis
	ypos = ypos + ydis
	incombatcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(incombatcheck:GetName() .. 'Text'):SetText(" fade in combat")
	incombatcheck.tooltip = "fade chat if combat starts"
	if scfOptions.incombat ~= nil then
		incombatcheck:SetChecked(scfOptions.incombat)
	else
		incombatcheck:SetChecked(defaults.incombat)
	end
	incombatcheck:SetScript("OnClick", 
	function()
		scf:setincombat(incombatcheck:GetChecked())
	end
	);
	
	suppresscheck = CreateFrame("CheckButton", "suppress", panel, templatecheck)
	ypos = ypos + ydis
	suppresscheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(suppresscheck:GetName() .. 'Text'):SetText(" suppress chat events during combat")
	suppresscheck.tooltip = "keeps chat hidden in combat no matter what"
	if scfOptions.suppress ~= nil then
		suppresscheck:SetChecked(scfOptions.suppress)
	else
		suppresscheck:SetChecked(defaults.suppress)
	end
	suppresscheck:SetScript("OnClick", 
	function()
		scf:setsuppress(suppresscheck:GetChecked())
	end
	);
	
	aftercombatcheck = CreateFrame("CheckButton", "aftercombat", panel, templatecheck)
	ypos = ypos + ydis
	aftercombatcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(aftercombatcheck:GetName() .. 'Text'):SetText(" show chat after combat ends")
	aftercombatcheck.tooltip = "shows chat after combat ends"
	if scfOptions.aftercombat ~= nil then
		aftercombatcheck:SetChecked(scfOptions.aftercombat)
	else
		aftercombatcheck:SetChecked(defaults.aftercombat)
	end
	aftercombatcheck:SetScript("OnClick", 
	function()
		scf:setaftercombat(aftercombatcheck:GetChecked())
	end
	);

	chatcheck = CreateFrame("CheckButton", "chat", panel, templatecheck)
	ypos = ypos + ydis
	ypos = ypos + ydis
	chatcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(chatcheck:GetName() .. 'Text'):SetText(" show chat for these events: ")
	chatcheck.tooltip = "if you only want combat to hide chat you should uncheck this"
	if scfOptions.chat ~= nil then
		chatcheck:SetChecked(scfOptions.chat)
	else
		chatcheck:SetChecked(defaults.chat)
	end
	chatcheck:SetScript("OnClick", 
	function()
			scf:setchat(chatcheck:GetChecked())
	end
	);

	xpos = xpos + 25

	whispercheck = CreateFrame("CheckButton", "whisper", panel, templatecheck)
	ypos = ypos + ydis
	whispercheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(whispercheck:GetName() .. 'Text'):SetText(" whisper")
	if scfOptions.whisper ~= nil then
		whispercheck:SetChecked(scfOptions.whisper)
	else
		whispercheck:SetChecked(defaults.whisper)
	end
	whispercheck:SetScript("OnClick", 
	function()
			scf:setwhisper(whispercheck:GetChecked())
	end
	);

	saycheck = CreateFrame("CheckButton", "say", panel, templatecheck)
	ypos = ypos + ydis
	saycheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(saycheck:GetName() .. 'Text'):SetText(" say")
	if scfOptions.say ~= nil then
		saycheck:SetChecked(scfOptions.say)
	else
		saycheck:SetChecked(defaults.say)
	end
	saycheck:SetScript("OnClick", 
	function()
			scf:setsay(saycheck:GetChecked())
	end
	);
	
	yellcheck = CreateFrame("CheckButton", "yell", panel, templatecheck)
	ypos = ypos + ydis
	yellcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(yellcheck:GetName() .. 'Text'):SetText(" yell")
	if scfOptions.yell ~= nil then
		yellcheck:SetChecked(scfOptions.yell)
	else
		yellcheck:SetChecked(defaults.yell)
	end
	yellcheck:SetScript("OnClick", 
	function()
			scf:setyell(yellcheck:GetChecked())
	end
	);
	
	guildcheck = CreateFrame("CheckButton", "guild", panel, templatecheck)
	ypos = ypos + ydis
	guildcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(guildcheck:GetName() .. 'Text'):SetText(" guild")
	if scfOptions.guild ~= nil then
		guildcheck:SetChecked(scfOptions.guild)
	else
		guildcheck:SetChecked(defaults.guild)
	end
	guildcheck:SetScript("OnClick", 
	function()
			scf:setguild(guildcheck:GetChecked())
	end
	);
	
	partycheck = CreateFrame("CheckButton", "party", panel, templatecheck)
	ypos = ypos + ydis
	partycheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(partycheck:GetName() .. 'Text'):SetText(" party")
	if scfOptions.party ~= nil then
		partycheck:SetChecked(scfOptions.party)
	else
		partycheck:SetChecked(defaults.party)
	end
	partycheck:SetScript("OnClick", 
	function()
			scf:setparty(partycheck:GetChecked())
	end
	);
	
	raidcheck = CreateFrame("CheckButton", "raid", panel, templatecheck)
	ypos = ypos + ydis
	raidcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(raidcheck:GetName() .. 'Text'):SetText(" raid")
	if scfOptions.raid ~= nil then
		raidcheck:SetChecked(scfOptions.raid)
	else
		raidcheck:SetChecked(defaults.raid)
	end
	raidcheck:SetScript("OnClick", 
	function()
			scf:setraid(raidcheck:GetChecked())
	end
	);
	
	instancecheck = CreateFrame("CheckButton", "instance", panel, templatecheck)
	ypos = ypos + ydis
	instancecheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(instancecheck:GetName() .. 'Text'):SetText(" instance")
	instancecheck.tooltip = "this can be bg/raid/scenario/LFR chat"
	if scfOptions.instance ~= nil then
		instancecheck:SetChecked(scfOptions.instance)
	else
		instancecheck:SetChecked(defaults.instance)
	end
	instancecheck:SetScript("OnClick", 
	function()
			scf:setinstance(instancecheck:GetChecked())
	end
	);
	
	commcheck = CreateFrame("CheckButton", "comm", panel, templatecheck)
	ypos = ypos + ydis
	commcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(commcheck:GetName() .. 'Text'):SetText(" community")
	--commcheck.tooltip = "this can be bg/raid/scenario/LFR chat"
	if scfOptions.comm ~= nil then
		commcheck:SetChecked(scfOptions.comm)
	else
		commcheck:SetChecked(defaults.comm)
	end
	commcheck:SetScript("OnClick", 
	function()
			scf:setcomm(commcheck:GetChecked())
	end
	);

	avmcheck = CreateFrame("CheckButton", "avm", panel, templatecheck)
	ypos = ypos + ydis
	avmcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(avmcheck:GetName() .. 'Text'):SetText(" achievements")
	if scfOptions.avm ~= nil then
		avmcheck:SetChecked(scfOptions.avm)
	else
		avmcheck:SetChecked(defaults.avm)
	end
	avmcheck:SetScript("OnClick", 
	function()
			scf:setavm(avmcheck:GetChecked())
	end
	);

	emotecheck = CreateFrame("CheckButton", "emote", panel, templatecheck)
	ypos = ypos + ydis
	emotecheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(emotecheck:GetName() .. 'Text'):SetText(" emotes")
	if scfOptions.emote ~= nil then
		emotecheck:SetChecked(scfOptions.emote)
	else
		emotecheck:SetChecked(defaults.emote)
	end
	emotecheck:SetScript("OnClick", 
	function()
			scf:setemote(emotecheck:GetChecked())
	end
	);

	monstercheck = CreateFrame("CheckButton", "monster", panel, templatecheck)
	ypos = ypos + ydis
	monstercheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(monstercheck:GetName() .. 'Text'):SetText(" monster")
	monstercheck.tooltip = "anything environment related"
	if scfOptions.monster ~= nil then
		monstercheck:SetChecked(scfOptions.monster)
	else
		monstercheck:SetChecked(defaults.monster)
	end
	monstercheck:SetScript("OnClick", 
	function()
			scf:setmonster(monstercheck:GetChecked())
	end
	);

	systemcheck = CreateFrame("CheckButton", "system", panel, templatecheck)
	ypos = ypos + ydis
	systemcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(systemcheck:GetName() .. 'Text'):SetText(" system messages")
	systemcheck.tooltip = "stuff like /played, /who and general yellow system text"
	if scfOptions.system ~= nil then
		systemcheck:SetChecked(scfOptions.system)
	else
		systemcheck:SetChecked(defaults.system)
	end
	systemcheck:SetScript("OnClick", 
	function()
			scf:setsystem(systemcheck:GetChecked())
	end
	);
	
	
	
	chmsgcheck = CreateFrame("CheckButton", "chmsg", panel, templatecheck)
	ypos = ypos + ydis
	chmsgcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(chmsgcheck:GetName() .. 'Text'):SetText(" track channels (by number or name) : ")
	chmsgcheck.tooltip = "if this is checked and you don't list channels, every channel will be tracked, otherwise only the ones that you list"
	if scfOptions.chmsg ~= nil then
		chmsgcheck:SetChecked(scfOptions.chmsg)
	else
		chmsgcheck:SetChecked(defaults.chmsg)
	end
	chmsgcheck:SetScript("OnClick", 
	function()
			scf:setchmsg(chmsgcheck:GetChecked())
	end
	);

	

	channeltext = panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	channeltext:SetPoint("TOPLEFT", xpos+115, ypos-30)
	channeltext:SetText(scf:ArrayToString(scfChannels))
	
	chnumbox = CreateFrame("EditBox", nil, panel, "InputBoxTemplate")
	chnumbox:SetPoint("TOPLEFT", xpos+10, ypos)
	chnumbox:SetWidth(100)
	chnumbox:SetHeight(70)
	chnumbox:SetMovable(false)
	chnumbox:SetAutoFocus(false)
	chnumbox:SetMultiLine(false)
	chnumbox.tooltip = "insert channel numbers or channel names ONE AT A TIME"
	chnumbox:SetScript("OnEnterPressed", 
	function()
			if chnumbox:GetNumber() ~= 0 then
				scf:setchnum(chnumbox:GetNumber())
			else
				scf:setchnum(chnumbox:GetText())
			end
			chnumbox:ClearFocus()
			chnumbox:SetText("")
			channeltext:SetText(scf:ArrayToString(scfChannels))
	end
	)
	
	
	
	
	ypos = ypos + ydis*2 + ydis*2
	xpos = xpos - 25
	
	idletimerslider = CreateFrame("Slider", "idletimersliderGlobalName", panel, "OptionsSliderTemplate")
	idletimerslider:SetPoint("TOPLEFT", xpos, ypos)
	idletimerslider:SetWidth(150)
	idletimerslider:SetHeight(15)
	idletimerslider:SetOrientation('HORIZONTAL')
	getglobal(idletimerslider:GetName() .. 'Low'):SetText('1 sec'); --Sets the left-side slider text (default is "Low").
	getglobal(idletimerslider:GetName() .. 'High'):SetText('30 sec'); --Sets the right-side slider text (default is "High").
	getglobal(idletimerslider:GetName() .. 'Text'):SetText('time until chat hides'); --Sets the "title" text (top-centre of slider).
	idletimerslider:SetMinMaxValues(1, 30)
	if scfOptions.idletimer ~= nil then
		idletimerslider:SetValue(scfOptions.idletimer)
	else
		idletimerslider:SetValue(defaults.idletimer)
	end
	idletimerslider:SetValueStep(1)
	idletimerslider:SetScript("OnValueChanged",
	function(self,event,arg1)
		local roundedidletimer = scf:Round(event, 0)	
		scf:setidletimer(roundedidletimer)
		idletimertext:SetText(roundedidletimer .. " sec")
	end)
		
	idletimertext = panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	idletimertext:SetPoint("TOP", idletimerslider, "BOTTOM")
	idletimertext:SetText(scfOptions.idletimer  .. " sec")

	
	--ypos = ypos + ydis*3
	xpos = xpos + 250
	
	fadealphaslider = CreateFrame("Slider", "fadealphasliderGlobalName", panel, "OptionsSliderTemplate")
	fadealphaslider:SetPoint("TOPLEFT", xpos, ypos)
	fadealphaslider:SetWidth(150)
	fadealphaslider:SetHeight(15)
	fadealphaslider:SetOrientation('HORIZONTAL')
	getglobal(fadealphaslider:GetName() .. 'Low'):SetText('0%'); --Sets the left-side slider text (default is "Low").
	getglobal(fadealphaslider:GetName() .. 'High'):SetText('100%'); --Sets the right-side slider text (default is "High").
	getglobal(fadealphaslider:GetName() .. 'Text'):SetText('alpha of faded chat, 0% = fully hidden'); --Sets the "title" text (top-centre of slider).
	fadealphaslider:SetMinMaxValues(0, 100)
	if scfOptions.fadealpha ~= nil then
		fadealphaslider:SetValue(scfOptions.fadealpha)
	else
		fadealphaslider:SetValue(defaults.fadealpha)
	end
	fadealphaslider:SetValueStep(4)
	fadealphaslider:SetScript("OnValueChanged", 
	function(self,event,arg1) 
		local roundedfadealpha = scf:Round(event, 0)
		scf:setfadealpha(roundedfadealpha) 
		fadealphatext:SetText(roundedfadealpha .. "%")	
		scf:showChat()
		scf:hideChat()
	end)
	
	fadealphatext = panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	fadealphatext:SetPoint("TOP", fadealphaslider, "BOTTOM")
	fadealphatext:SetText(scfOptions.fadealpha .. "%")
	
	--[[
	xpos = xpos - 250
	
	hideminimapcheck = CreateFrame("CheckButton", "hideminimap", panel, templatecheck)
	ypos = ypos + ydis*2
	hideminimapcheck:SetPoint("TOPLEFT", xpos, ypos)
	getglobal(hideminimapcheck:GetName() .. 'Text'):SetText(" hide minimap too (WIP)")
	hideminimapcheck.tooltip = "this simply hides minimap whenever your chat fades. \n /reload after changing"
	if scfOptions.hideminimap ~= nil then
		hideminimapcheck:SetChecked(scfOptions.hideminimap)
	else
		hideminimapcheck:SetChecked(defaults.hideminimap)
	end
	hideminimapcheck:SetScript("OnClick", 
	function()
			scf:sethideminimap(hideminimapcheck:GetChecked())
	end
	);
	]]--

end

function DeepPrint (e)
	if type(e) == "table" then
		for k,v in pairs(e) do 
			if k == "exec" then
				print(k)
			end
			DeepPrint(v)       
		end
	else 
		print(e)
	end
end

function scf:default()
	scf:setinraid(defaults.inraid)
	inraidcheck:SetChecked(defaults.inraid)
	
	scf:setincombat(defaults.incombat)
	incombatcheck:SetChecked(defaults.incombat)
	
	scf:setsuppress(defaults.suppress)
	suppresscheck:SetChecked(defaults.suppress)
	
	scf:setaftercombat(defaults.aftercombat)
	aftercombattcheck:SetChecked(defaults.aftercombat)
	
	scf:setchat(defaults.chat)
	chatcheck:SetChecked(defaults.chat)
	
	scf:setwhisper(defaults.whisper)
	whispercheck:SetChecked(defaults.whisper)
	
	scf:setsay(defaults.say)
	saycheck:SetChecked(defaults.say)
	
	scf:setyell(defaults.yell)
	yellcheck:SetChecked(defaults.yell)
	
	scf:setguild(defaults.guild)
	guildcheck:SetChecked(defaults.guild)
	
	scf:setparty(defaults.party)
	partycheck:SetChecked(defaults.party)
	
	scf:setraid(defaults.raid)
	raidcheck:SetChecked(defaults.raid)
	
	scf:setinstance(defaults.instance)
	instancecheck:SetChecked(defaults.instance)
	
	scf:setcomm(defaults.comm)
	commcheck:SetChecked(defaults.comm)
	
	scf:setavm(defaults.avm)
	avmcheck:SetChecked(defaults.avm)
	
	scf:setemote(defaults.emote)
	emotecheck:SetChecked(defaults.emote)
	
	scf:setmonster(defaults.monster)
	monstercheck:SetChecked(defaults.monster)
	
	scf:setsystem(defaults.system)
	systemcheck:SetChecked(defaults.system)
	
	scf:setchmsg(defaults.chmsg)
	chmsgcheck:SetChecked(defaults.chmsg)
	
	scfChannels = {}
	channeltext:SetText(scf:ArrayToString(scfChannels))
	
	scf:setidletimer(defaults.idletimer)
	idletimerslider:SetValue(defaults.idletimer)
	
	scf:setfadealpha(defaults.fadealpha)
	fadealphaslider:SetValue(defaults.fadealpha)
	
	--[[
	scf:sethideminimap(defaults.hideminimap)
	hideminimapcheck:SetChecked(defaults.hideminimap)
	]]--
end

function scf:okay()
	--todo
end

function scf:cancel()
	print(scfOptions.system)
	print(preSettings.system)
	scf:setinraid(preSettings.inraid)
	inraidcheck:SetChecked(preSettings.inraid)
	
	--todo incombat
	--todo suppress
	--todo aftercombat
	
	scf:setchat(preSettings.chat)
	chatcheck:SetChecked(preSettings.chat)
	
	scf:setwhisper(preSettings.whisper)
	whispercheck:SetChecked(preSettings.whisper)
	
	scf:setsay(preSettings.say)
	saycheck:SetChecked(preSettings.say)
	
	scf:setyell(preSettings.yell)
	yellcheck:SetChecked(preSettings.yell)
	
	scf:setguild(preSettings.guild)
	guildcheck:SetChecked(preSettings.guild)
	
	scf:setparty(preSettingss.party)
	partycheck:SetChecked(preSettings.party)
	
	scf:setraid(preSettings.raid)
	raidcheck:SetChecked(preSettings.raid)
	
	scf:setinstance(preSettings.instance)
	instancecheck:SetChecked(preSettings.instance)
	
	scf:setcomm(preSettings.comm)
	commcheck:SetChecked(preSettings.comm)
	
	scf:setavm(preSettings.avm)
	avmcheck:SetChecked(preSettings.avm)
	
	scf:setemote(preSettings.emote)
	emotecheck:SetChecked(preSettings.emote)
	
	scf:setmonster(preSettings.monster)
	monstercheck:SetChecked(preSettings.monster)
	
	scf:setsystem(preSettings.system)
	systemcheck:SetChecked(preSettings.system)
	
	scf:setchmsg(preSettings.chmsg)
	chmsgcheck:SetChecked(preSettings.chmsg)
	
	scfChannels = {}
	scfChannels = table.copy(preChannels)
	channeltext:SetText(scf:ArrayToString(scfChannels))
	
	scf:setidletimer(preSettings.idletimer)
	idletimerslider:SetValue(preSettings.idletimer)
	
	scf:setfadealpha(preSettings.fadealpha)
	fadealphaslider:SetValue(preSettings.fadealpha)
end


function scf:setincombat(setting)
	scfOptions.incombat = setting
	if setting or scfOptions.aftercombat then
		event:RegisterEvent("PLAYER_REGEN_ENABLED")
		event:RegisterEvent("PLAYER_REGEN_DISABLED")
	else
		event:UnregisterEvent("PLAYER_REGEN_ENABLED")
		event:UnregisterEvent("PLAYER_REGEN_DISABLED")
	end
	
	if setting then
		scf:showChat()
	end
end

function scf:setaftercombat(setting)
	scfOptions.aftercombat = setting
	if setting or scfOptions.incombat then
		event:RegisterEvent("PLAYER_REGEN_ENABLED")
		event:RegisterEvent("PLAYER_REGEN_DISABLED")
	else
		event:UnregisterEvent("PLAYER_REGEN_ENABLED")
		event:UnregisterEvent("PLAYER_REGEN_DISABLED")
	end
	
	if setting then
		scf:showChat()
	end

end

function scf:setsuppress(setting)
	scfOptions.suppress = setting
end

function scf:setsystem(setting)
	scfOptions.system = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_SYSTEM")
		event:RegisterEvent("TIME_PLAYED_MSG")
		event:RegisterEvent("WHO_LIST_UPDATE")
	else
		event:UnregisterEvent("CHAT_MSG_SYSTEM")
		event:UnregisterEvent("TIME_PLAYED_MSG")
		event:UnregisterEvent("WHO_LIST_UPDATE")
	end
end

function scf:setmonster(setting)
	scfOptions.monster = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
		event:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
		event:RegisterEvent("CHAT_MSG_MONSTER_WHISPER")
	else
		event:UnregisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
		event:UnregisterEvent("CHAT_MSG_MONSTER_EMOTE")
		event:UnregisterEvent("CHAT_MSG_MONSTER_WHISPER")
	end
end

function scf:setemote(setting)
	scfOptions.emote = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_EMOTE")
		event:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
	else
		event:UnregisterEvent("CHAT_MSG_EMOTE")
		event:UnregisterEvent("CHAT_MSG_TEXT_EMOTE")
	end
end

function scf:setavm(setting)
	scfOptions.avm = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
		event:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
	else
		event:UnregisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
		event:UnregisterEvent("CHAT_MSG_ACHIEVEMENT")
	end
end

function scf:setcomm(setting)
	scfOptions.comm = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_COMMUNITIES_CHANNEL")
	else
		event:UnregisterEvent("CHAT_MSG_COMMUNITIES_CHANNEL")
	end
end

function scf:setinstance(setting)
	scfOptions.instance = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_INSTANCE_CHAT")
		event:RegisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
	else
		event:UnregisterEvent("CHAT_MSG_INSTANCE_CHAT")
		event:UnregisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
	end
end

function scf:setraid(setting)
	scfOptions.raid = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_RAID_LEADER")
		event:RegisterEvent("CHAT_MSG_RAID")
	else
		event:UnregisterEvent("CHAT_MSG_RAID_LEADER")
		event:UnregisterEvent("CHAT_MSG_RAID")
	end
end

function scf:setparty(setting)
	scfOptions.party = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_PARTY_LEADER")
		event:RegisterEvent("CHAT_MSG_PARTY")
	else
		event:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
		event:UnregisterEvent("CHAT_MSG_PARTY")
	end
end

function scf:setguild(setting)
	scfOptions.guild = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_GUILD")
		event:RegisterEvent("CHAT_MSG_OFFICER")
	else
		event:UnregisterEvent("CHAT_MSG_GUILD")
		event:UnregisterEvent("CHAT_MSG_OFFICER")
	end
end

function scf:setyell(setting)
	scfOptions.yell = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_MONSTER_YELL")
		event:RegisterEvent("CHAT_MSG_YELL")
	else
		event:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
		event:UnregisterEvent("CHAT_MSG_YELL")	
	end
end

function scf:setsay(setting)
	scfOptions.say = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_SAY")
		event:RegisterEvent("CHAT_MSG_MONSTER_SAY")
	else
		event:UnregisterEvent("CHAT_MSG_SAY")
		event:UnregisterEvent("CHAT_MSG_MONSTER_SAY")	
	end
end

function scf:setchmsg(setting)
	scfOptions.chmsg = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_CHANNEL")
	else
		event:UnregisterEvent("CHAT_MSG_CHANNEL")
	end
end

function scf:setchnum(number)
	if number ~= "" then
		if scfChannels[number] then
			scfChannels[number] = nil
		else
			scfChannels[number] = true
		end
	end
end


function scf:setwhisper(setting)
	scfOptions.whisper = setting
	if setting then
		event:RegisterEvent("CHAT_MSG_WHISPER")
		event:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
		event:RegisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
		event:RegisterEvent("CHAT_MSG_BN_WHISPER")
	else
		event:UnregisterEvent("CHAT_MSG_WHISPER")
		event:UnregisterEvent("CHAT_MSG_WHISPER_INFORM")
		event:UnregisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
		event:UnregisterEvent("CHAT_MSG_BN_WHISPER")		
	end
end


function scf:setchat(setting)
	scfOptions.chat = setting
	if setting then
		if scfOptions.whisper ~= nil then
			scf:setwhisper(scfOptions.whisper)
		else
			scf:setwhisper(defaults.whisper)
		end
		if scfOptions.say ~= nil then
			scf:setsay(scfOptions.say)
		else
			scf:setsay(defaults.say)
		end
		if scfOptions.yell ~= nil then
			scf:setyell(scfOptions.yell)
		else
			scf:setyell(defaults.yell)
		end
		if scfOptions.guild ~= nil then
			scf:setguild(scfOptions.guild)
		else
			scf:setguild(defaults.guild)
		end
		if scfOptions.party ~= nil then
			scf:setparty(scfOptions.party)
		else
			scf:setparty(defaults.party)
		end
		if scfOptions.raid ~= nil then
			scf:setraid(scfOptions.raid)
		else
			scf:setraid(defaults.raid)
		end
		if scfOptions.instance ~= nil then
			scf:setinstance(scfOptions.instance)
		else
			scf:setinstance(defaults.instance)
		end
		if scfOptions.comm ~= nil then
			scf:setcomm(scfOptions.comm)
		else
			scf:setcomm(defaults.comm)
		end
		if scfOptions.avm ~= nil then
			scf:setavm(scfOptions.avm)
		else
			scf:setavm(defaults.avm)
		end
		if scfOptions.emote ~= nil then
			scf:setemote(scfOptions.emote)
		else
			scf:setemote(defaults.emote)
		end
		if scfOptions.monster ~= nil then
			scf:setmonster(scfOptions.monster)
		else
			scf:setmonster(defaults.monster)
		end
		if scfOptions.system ~= nil then
			scf:setsystem(scfOptions.system)
		else
			scf:setsystem(defaults.system)
		end
	
	else
		event:UnregisterEvent("CHAT_MSG_SYSTEM")
		event:UnregisterEvent("TIME_PLAYED_MSG")
		event:UnregisterEvent("WHO_LIST_UPDATE")
		event:UnregisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
		event:UnregisterEvent("CHAT_MSG_MONSTER_EMOTE")
		event:UnregisterEvent("CHAT_MSG_MONSTER_WHISPER")
		event:UnregisterEvent("CHAT_MSG_EMOTE")
		event:UnregisterEvent("CHAT_MSG_TEXT_EMOTE")
		event:UnregisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
		event:UnregisterEvent("CHAT_MSG_ACHIEVEMENT")
		event:UnregisterEvent("CHAT_MSG_COMMUNITIES_CHANNEL")
		event:UnregisterEvent("CHAT_MSG_INSTANCE_CHAT")
		event:UnregisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
		event:UnregisterEvent("CHAT_MSG_RAID_LEADER")
		event:UnregisterEvent("CHAT_MSG_RAID")
		event:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
		event:UnregisterEvent("CHAT_MSG_PARTY")
		event:UnregisterEvent("CHAT_MSG_GUILD")
		event:UnregisterEvent("CHAT_MSG_OFFICER")
		event:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
		event:UnregisterEvent("CHAT_MSG_YELL")	
		event:UnregisterEvent("CHAT_MSG_SAY")
		event:UnregisterEvent("CHAT_MSG_MONSTER_SAY")	
		event:UnregisterEvent("CHAT_MSG_WHISPER")
		event:UnregisterEvent("CHAT_MSG_WHISPER_INFORM")
		event:UnregisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
		event:UnregisterEvent("CHAT_MSG_BN_WHISPER")	
	end
end

function scf:setinraid(setting)
	scfOptions.inraid = setting
	if setting then
		scf:showChat()
	end
end

function scf:sett(setting)
	scfOptions.t = setting
end

function scf:setidletimer(setting)
	scfOptions.idletimer = setting
	isIdle = false
end

function scf:setfadealpha(setting)
	scfOptions.fadealpha = setting
end

--[[
function scf:sethideminimap(setting)
	scfOptions.hideminimap = setting
end
]]--

function idle:onUpdate(sinceLastUpdate)

	if ( (self.sinceLastUpdate or 0) < scfOptions.idletimer ) then
		self.sinceLastUpdate = (self.sinceLastUpdate or 0) + sinceLastUpdate
		return
	else

		if not(isIdle) then
			if (((scfOptions.inraid and IsInRaid()) or not(scfOptions.inraid)) and (scfOptions.chat or (UnitAffectingCombat("player") and scfOptions.incombat))) then
				isIdle = true
				self.sinceLastUpdate = 0
				scf:hideChat()
			end
		end
		
	end
	
end



function scf:Init()
	scf:getOptions()
	scf:createPanel()
	chatCVar = GetCVar("chatStyle") --either classic or im
	scf:hookChat()
	
	idle:SetScript("OnUpdate",idle.onUpdate) --todo find a solution that is not onupdate
	--C_Timer.After(scfOptions.idletimer, scf:hideTest())
	
	for i=1,NUM_CHAT_WINDOWS do
		local f = _G["ChatFrame"..i]
		if(f:IsShown()) then
			--f:SetTimeVisible(7200)
			local chatMouseover = CreateFrame("Frame", "scf"..i, UIParent)
			chatMouseover:SetPoint("BOTTOMLEFT", "ChatFrame"..i, "BOTTOMLEFT", -20, -10)
			chatMouseover:SetPoint("TOPRIGHT", "ChatFrame"..i, "TOPRIGHT", 10, 10)

			chatMouseover.FadeOut = function (self) scf:FadeOut(self) end
			chatMouseover.FadeIn = function (self) scf:FadeIn(self) end
			
			chatMouseover:SetScript("OnEnter", function(self)
				self:FadeIn(self) --todo? maybe trigger this through showchat?
				isIdle = false
				idle.sinceLastUpdate = 0
			end)
			--chatMouseover:SetScript("OnLeave", function(self)
			--	scf:ChatOnLeave(self)
				--idle.sinceLastUpdate = 0
			--end)
			
			chatMouseover.Frames = {_G["ChatFrame"..i], _G["ChatFrame"..i.."Tab"], _G["ChatFrame"..i.."ButtonFrame"]}
			if (i==1) then
				table.insert(chatMouseover.Frames, GeneralDockManager)
				table.insert(chatMouseover.Frames, GeneralDockManagerScrollFrame)
				if ChatFrameMenuButton:IsShown() then
					table.insert(chatMouseover.Frames, ChatFrameMenuButton)
				end
				table.insert(chatMouseover.Frames, QuickJoinToastButton)
				table.insert(chatMouseover.Frames, ChatFrameChannelButton)
				--table.insert(chatMouseover.Frames, ChatFrame1EditBox)
			end		
			chatMouseover:SetFrameStrata("BACKGROUND")
			table.insert(MouseoverFrames, _G["scf"..i])
		end
	end
	--[[
	if scfOptions.hideminimap then
		local miniMap = {
			[100] = "Minimap",
			[101] = "MinimapZoneTextButton",
			[102] = "MinimapCluster",
		}
		
		for index,value in pairs(miniMap) do
			local f = _G[value]
			local minimapMouseover = CreateFrame("Frame", "scf"..index, UIParent)
			minimapMouseover:SetPoint("BOTTOMLEFT", value, "BOTTOMLEFT", -20, -10)
			minimapMouseover:SetPoint("TOPRIGHT", value, "TOPRIGHT", 10, 10)
			print(Minimap:GetChildren())
			minimapMouseover.FadeOut = function (self) scf:FadeOut(self) end
			minimapMouseover.FadeIn = function (self) scf:FadeIn(self) end
			minimapMouseover:SetScript("OnEnter", function(self)
						self:FadeIn(self) --todo? maybe trigger this through showchat?
						isIdle = false
						idle.sinceLastUpdate = 0
					end)
			minimapMouseover.Frames = {_G[value]}
			minimapMouseover:SetFrameStrata("BACKGROUND")
			--minimapMouseover:SetBackdrop({ bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, edgeSize = 10, tileSize = 10, insets = { left = 1, right = 1, top = 1, bottom = 1, }, })
			table.insert(MouseoverFrames, _G["scf"..index])
		end
	end
	]]--
end

--
function scf:hideChat()
		for _, f in pairs(MouseoverFrames) do
			f:FadeOut()
		end
	isIdle = true
end

--
function scf:showChat()
	if (UnitAffectingCombat("player") and scfOptions.suppress) then
		return --todo put this outside off showChat
	end

	for _, f in pairs(MouseoverFrames) do
		f:FadeIn()
	end
	idle.sinceLastUpdate = 0
	isIdle = false
end

--Fade
--0: fade in, 1: fade out
function scf:FadeOut(self)
	scf:fade(self, 1)
end
function scf:FadeIn(self)
	scf:fade(self, 0)
end
function scf:fade(self, mode)
	for _, frame in pairs(self.Frames) do
		local alpha = frame:GetAlpha()
		--fade in
		if mode == 0 then
			frame.Show = Show
			frame:Show()
			UIFrameFadeIn(frame, scfOptions.t*(1-alpha), alpha, 1)
		--fade out
		else
			UIFrameFadeOut(frame, scfOptions.t*alpha, alpha, (scfOptions.fadealpha / 100))
			frame.Show = function() end
			if scfOptions.fadealpha == 0 and frame.fadeInfo then
				frame.fadeInfo.finishedArg1 = frame
				frame.fadeInfo.finishedFunc = frame.Hide
			end
		end
	end	
end

--[[
function scf:ChatOnLeave(self)
	local f = GetMouseFocus()
	if f then
		if f.messageInfo then
			return nil
		end
		if scf:IsInArray(self.Frames, f) then
			return nil
		end
		if f:GetParent() then
			f = f:GetParent()
			if scf:IsInArray(self.Frames, f) then
				return nil
			end
			if f:GetParent() then
				f = f:GetParent()
				if scf:IsInArray(self.Frames, f) then
					return nil
				end
			end
		end
	end

	--if UnitAffectingCombat("player") or C_PetBattles.IsInBattle() or isIdle then
	--	idle.sinceLastUpdate = 0
	--	self:FadeOut(self)
	--end
end
]]--


--WorldFrame:HookScript("OnEnter", function()
--	if UnitAffectingCombat("player") or C_PetBattles.IsInBattle() then
--		scf:hideChat()
--	end
--end)

function scf:IsInArray(array, s)
	for _, v in pairs(array) do
		if (v == s) then
			return true
		end
	end
	return false
end


function scf:ArrayToString(array)
	local string = ""
	for k, _ in pairs(array) do
		if string == "" then
			string = '"' .. k.. '"'
		else
			string = string .. ', "' .. k .. '"'
		end		
	end
	if string == "" then
		string = "tracking all channels"
	end
	return string
end

function scf:Round(num, dp)
    --[[
    round a number to so-many decimal of places, which can be negative, 
    e.g. -1 places rounds to 10's,  
    
    examples
        173.2562 rounded to 0 dps is 173.0
        173.2562 rounded to 2 dps is 173.26
        173.2562 rounded to -1 dps is 170.0
    ]]--
    local mult = 10^(dp or 0)
    return math.floor(num * mult + 0.5)/mult
end

hooksecurefunc("FCF_Tab_OnClick", function(self)
	chatFrame = _G["ChatFrame"..self:GetID()];
	if (chatFrame.isDocked) then
		scf1.Frames[1] = chatFrame
	end
	--print(SELECTED_CHAT_FRAME:GetID())
	activeChannels = { GetChatWindowMessages(SELECTED_CHAT_FRAME:GetID()) }
	activeChannellist = { GetChannelList() }
	--DeepPrint(activeChannellist)
	--DeepPrint(activeChannels)
	if (chatCVar == "im") then
		local eb = _G['ChatFrame'..self:GetID()..'EditBox']
		eb:Hide()
	end
end)

function scf:hookChat()
	for i = 1, NUM_CHAT_WINDOWS do
		local eb = _G['ChatFrame'..i..'EditBox']
		if (chatCVar == "im") then
			eb:Hide()
			eb:HookScript('OnEnterPressed', function(s) s:Hide() end)
		end
		--eb:HookScript('OnShow', function(s) scf:showChat() end)
		eb:HookScript("OnEditFocusGained", function(s) scf:showChat() end)
	end
end